<template>
  <SinglePane capt="Участники">
    <div class="organizations-container">
      <ObTable
        :items="participants"
        :columns="columns"
        :selected="{}"
        :functional-panel="true"
        :loading="pending"
        :is-functional-group="false"
        :is-functional-sort="false"
        :table-layout-fixed="true"
        @select="onSelect"
      >
        <template
          slot="risks"
          slot-scope="{ data }"
        >
          <template v-if="data.item.risks.length">
            <div
              v-for="(item, i) in data.item.risks"
              :key="i"
            >
              <div
                v-if="item.riskGroupColor"
                class="risk-group"
              >
                <span v-html="getRiskIcon(item.riskGroupColor)" />
                <div>
                  <span>{{ item.activity }}</span>
                  <ObTooltip
                    v-if="item.isTemporaryRisk"
                    :content="`Проверка участника ещё не завершена. Временно присвоена группа риска ${getNumberRisk(item.riskGroupColor)}`"
                  >
                    <span class="pending-risk">Временная оценка</span>
                  </ObTooltip>
                </div>
              </div>
            </div>
          </template>

          <ObTooltip
            v-else
            content="Оценка не проведена"
          >
            <i class="icon clock organizations-icon-clock -gray-window" />
          </ObTooltip>
        </template>
      </ObTable>
    </div>
  </SinglePane>
</template>

<script>
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import riskIconMixin from '@/mixins/risk-icon'
  import moment from 'moment'
  import api from '@/api'

  export default {
    components: {
      SinglePane,
      ObTable,
      ObTooltip
    },
    mixins: [
      riskIconMixin
    ],
    data () {
      return {
        pending: false,
        domainTitle: '',
        domainUuid: '',
        participants: [],
        columns: [
          {
            title: 'Роль',
            key: 'roleTitle'
          },
          {
            title: 'ИНН Организации',
            key: 'inn'
          },
          {
            title: 'Данные участника',
            key: 'title'
          },
          {
            title: 'Риск',
            key: 'risks',
            slotName: 'risks'
          },
          {
            title: 'Регистрация',
            key: 'registeredAt',
            sort: 'datetime',
            html: ({ registeredAt }) => this.getDatetimeHtml(registeredAt)
          },
          {
            title: 'Начало проверки',
            key: 'checkStartAt',
            sort: 'datetime',
            html: ({ checkStartAt }) => this.getDatetimeHtml(checkStartAt)
          },
          {
            title: 'Окончание проверки',
            key: 'checkEndAt',
            sort: 'datetime',
            html: ({ checkEndAt }) => this.getDatetimeHtml(checkEndAt)
          },
          {
            title: 'Дата оценки',
            key: 'checkDate',
            sort: 'datetime',
            html: ({ checkDate }) => this.getDatetimeHtml(checkDate)
          },
          {
            title: 'Подтверждение СБ',
            key: 'sbConfirm',
            sort: 'datetime',
            html: ({ sbConfirm }) => this.getDatetimeHtml(sbConfirm)
          }
        ]
      };
    },
    methods: {
      async fetch () {
        this.pending = true

        try {
          const { data } = await api.organisations.getParticipants()

          if (!data.domains.length) {
            this.pending = false

            return
          }

          this.domainTitle = data.domains[0].domainTitle
          this.domainUuid = data.domains[0].domainUuid
          this.participants = data.domains[0].participants
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        this.pending = false
      },
      // ✂️Utils
      getDatetimeHtml (datetime) {
        return datetime
          ? `
            <div class="field-datetime">
              <div>${moment(datetime)
                .locale('ru')
                .format('L')}</div>
              <div class="field-time">${moment(datetime)
                .locale('ru')
                .format('LT')}</div>
            </div>
          ` : ''
      },
      // 👂 Events
      onSelect (item) {
        this.$router.push({
          path: `/organizations/${item.participantUuid}`
        })
      }
    },
    created () {
      this.fetch()
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .organizations-container {
    position: relative;
    height: 100%;

    &::v-deep {
      .pending-risk {
        font-size: 12px;
        line-height: 12px;
        color: $saturated-yellow;
      }

      .risk-group {
        display: flex;
        align-items: center;
        margin-bottom: 10px;
        line-height: 15px;

        i {
          margin-right: 5px;
          font-size: 22px;
          left: -2px;
          position: relative;
        }

        &:last-child {
          margin-bottom: 0;
        }
      }

      .risk-icon {
        margin-right: 5px;
      }

      .field-datetime {
        @include font-mixin(14px, 20px, 400);

        .field-time {
          color: $color-grey-span;
        }
      }

      td > div {
        display: flex;
        align-items: center;
      }

      .icon.clock {
        font-size: 17px;

        &:before {
          color: $gray-window;
        }
      }
    }

    .organizations-icon-clock {
      cursor: help;
    }
  }
</style>
